package com.project.skidn_disease_app;

import android.os.Bundle;

import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.RetryPolicy;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.project.skidn_disease_app.Adapters.ChatRvAdpater;
import com.project.skidn_disease_app.model.ChatModal;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link ChatFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class ChatFragment extends Fragment {
    View view;
    private RecyclerView charsRv;
    private EditText userEdittext;
    private FloatingActionButton sendMsgBtn;
    private final String BOT_KEY = "bot";
    private final String USER_KEY = "user";
    private ArrayList<ChatModal> chatModals;
    private ChatRvAdpater chatRvAdpater;

    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    public ChatFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment ChatFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static ChatFragment newInstance(String param1, String param2) {
        ChatFragment fragment = new ChatFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }



    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
        getActivity().setTitle("Chat");
        getActivity().setTitleColor(R.color.bot_back_color);


    }
    private void getResponce(String msg,final VolleyCallBack callBack) throws JSONException {
        chatModals.add(new ChatModal(msg,USER_KEY));
        chatRvAdpater.notifyDataSetChanged();
        String url = "http://10.0.2.2:8000/api/chatbot";
        String baseurl = "http://10.0.2.2:8000/api/chatbot";
        String quary = "{\n  \"msg\": \"hi\"\n}";
        JSONObject jsonBody = new JSONObject(quary);
        System.out.println("here");
        JsonObjectRequest req = new JsonObjectRequest(Request.Method.POST,url, jsonBody, new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {
                System.out.println("RESPONCE");
                System.out.println(response);
                try {
                    String bot_msg = (String) response.get("msg");
                    System.out.println(bot_msg);
                    chatModals.add(new ChatModal(bot_msg,BOT_KEY));
                    chatRvAdpater.notifyDataSetChanged();
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                System.out.println(error.toString());
                chatModals.add(new ChatModal("Please Re-enter your message",BOT_KEY));
                System.out.println("ERROR");
            }
        });
        req.setRetryPolicy(new RetryPolicy() {
            @Override
            public int getCurrentTimeout() {
                return 5000000;
            }

            @Override
            public int getCurrentRetryCount() {
                return 5000000;
            }

            @Override
            public void retry(VolleyError error) throws VolleyError {

            }
        });
        RequestQueue requestQueue = Volley.newRequestQueue(this.getContext());
        requestQueue.add(req);
    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        view = inflater.inflate(R.layout.fragment_chat, container, false);
//        recyclerView = (RecyclerView) view.findViewById(R.id.medecrecyele_view);
        charsRv = view.findViewById(R.id.reChatView);
        userEdittext = view.findViewById(R.id.msgEt);
        sendMsgBtn = view.findViewById(R.id.idFBASend);
        chatModals  = new ArrayList<>();
        LinearLayoutManager  manager  = new LinearLayoutManager(this.getContext());
        chatRvAdpater = new ChatRvAdpater(chatModals,getContext());
        charsRv.setLayoutManager(manager);
        charsRv.setAdapter(chatRvAdpater);
        sendMsgBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(userEdittext.getText().toString().isEmpty()){
                    Toast.makeText(getContext(),"Please Enter Your Message",Toast.LENGTH_SHORT).show();
                    return;
                }
                System.out.println("ssssssssss");
                System.out.println(userEdittext.getText().toString().trim());
                System.out.println("ssssssssss");
                try {
                    getResponce(userEdittext.getText().toString().trim(), new VolleyCallBack() {
                        @Override
                        public void onSuccess() {
                            System.out.println("sucss");
                        }
                    });
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                userEdittext.setText("");
            }
        });

        return view;
    }
}