package com.project.skidn_disease_app;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.VolleyLog;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.firebase.auth.FirebaseAuth;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DutyCalling extends AppCompatActivity {

    EditText onDutyName,onDutyAddress,onDutyPhone,onDutyMon,onDutyTue,onDutyWen,onDutyThur,onDutyFri;
    private String Address,Phone,Name,Id,Email;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_duty_calling);
        onDutyAddress = findViewById(R.id.onDuty_address_et);
        onDutyPhone = findViewById(R.id.onDuty_ph_et);
        onDutyName = findViewById(R.id.onDuty_name_et);
        onDutyMon = findViewById(R.id.monday_et);
        onDutyTue = findViewById(R.id.tuesday_et);
        onDutyWen = findViewById(R.id.wensday_et);
        onDutyThur = findViewById(R.id.thursday_et);
        onDutyFri = findViewById(R.id.friday_et);
        String userId = FirebaseAuth.getInstance().getCurrentUser().getUid();
        System.out.println("dutycalling");
        System.out.println(userId);
        System.out.println("userId");
        try {
            setValues(userId);
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    public void setValues(String userID) throws JSONException {
        HashMap<String,String> jsonObject = getDoctors(userID,new VolleyCallBack() {
            @Override
            public void onSuccess() {
                System.out.println("hello onSuccess");
            }});


//
//        System.out.println(jsonObject.get("availability").getClass());
        System.out.println(jsonObject);


    }

    public void justafunction(String id,String name,String email,String permitNo,String phone,String address,final VolleyCallBack callBack) throws JSONException {
//        String url ="https://projects.vishnusivadas.com/testing/write.php";
        final String url = "https://i0qh9h.deta.dev/api/doctor/"+id;

        Map<String, Object> postParam= new HashMap<>();
        postParam.put("id", "getList");
        postParam.put("title", "10.0086575");
        postParam.put("name", "getList");
        postParam.put("phone", "getList");
        postParam.put("email", "getList");
        postParam.put("permitNo", "getList");
        postParam.put("address", "getList");
        postParam.put("availability", "[]");

        String quary = "{\n  \"id\": \""+id+"\",\n  \"title\":  \""+"Dr "+"\",\n  \"name\": \""+name+"\",\n  \"phone\": \"\",\n  \"email\": \""+email+"\",\n  \"permitNo\": \"\",\n  \"address\": \"\",\n  \"availability\": [\n]\n}";
        final JSONObject jsonBody = new JSONObject(quary);
        JsonObjectRequest req = new JsonObjectRequest(url, jsonBody,
                new Response.Listener<JSONObject>() {
                    @Override
                    public void onResponse(JSONObject response) {
                        try {
                            VolleyLog.v("Response:%n %s", response.toString(4));

                            callBack.onSuccess();

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                VolleyLog.e("Error: ", error.getMessage());
            }

        });

// add the request object to the queue to be executed
        RequestQueue queue = Volley.newRequestQueue(this);
        queue.add(req);
    }


    public void updateDoctor(String id,String name,String email,String permitNo,String title,String phone,String address,final VolleyCallBack callBack) throws JSONException {
        System.out.println(id);
        RequestQueue requestQueue = Volley.newRequestQueue(this);
//        String url = "https://i0qh9h.deta.dev/api/doctor/"+userId;
//        List<String> jsonResponses = new ArrayList<>();
//        HashMap<String,String> data = new HashMap<>();
//        final JSONObject[] jsonObject = new JSONObject[1];
//        RequestQueue requestQueue = Volley.newRequestQueue(this);
//        JsonObjectRequest jsonObjectRequest = new JsonObjectRequest(Request.Method.PUT, url, response -> {
//        }, error -> error.printStackTrace());
//
//        requestQueue.add(jsonObjectRequest);
//        System.out.println(data);
//        return data;
        final String url = "https://i0qh9h.deta.dev/api/doctor/"+id;
        JSONArray jsonArray = new JSONArray();
        Map<String, Object> params = new HashMap();
        params.put("id", id);
        params.put("title", title);
        params.put("phone", phone);
        params.put("email", email);
        params.put("permitNo", permitNo);
        params.put("address", address);
        params.put("availability", "[]");

        String quary = "{\n  \"id\": \""+id+"\",\n  \"title\":  \""+"Dr "+"\",\n  \"name\": \""+name+"\",\n  \"phone\":  \""+phone+"\",\n  \"email\": \""+email+"\",\n  \"permitNo\": \"\",\n  \"address\":  \""+address+"\",\n  \"availability\": [\n]\n}";
        JSONObject parameters = new JSONObject(quary);

        JsonObjectRequest jsonRequest = new JsonObjectRequest(Request.Method.PUT, url, parameters, new Response.Listener<JSONObject>() {
            @Override
            public void onResponse(JSONObject response) {
                //TODO: handle success
                System.out.println("----------");
                System.out.println(response.toString());
                System.out.println("On Success");
                System.out.println("----------");
            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                error.printStackTrace();
                System.out.println("----------");
                System.out.println("On Failure");
                System.out.println("----------");
            }
        });
        requestQueue.add(jsonRequest);
//        System.out.println(data);
    }


    public HashMap<String,String> getDoctors(String userId,final VolleyCallBack callBack){
        String url = "https://i0qh9h.deta.dev/api/doctor/"+userId;
        List<String> jsonResponses = new ArrayList<>();
        HashMap<String,String> data = new HashMap<>();
        final JSONObject[] jsonObject = new JSONObject[1];
        RequestQueue requestQueue = Volley.newRequestQueue(this);
        StringRequest jsonObjectRequest = new StringRequest(Request.Method.GET, url, response -> {
            System.out.println(response.getClass());
            try {
                jsonObject[0] = new JSONObject(response);
                System.out.println("request==============");
                System.out.println(jsonObject[0].get("address"));
                System.out.println(jsonObject[0].get("email"));
                data.put("address",jsonObject[0].get("address").toString());
                data.put("email",jsonObject[0].get("email").toString());
                Id = jsonObject[0].get("id").toString();
                Address = jsonObject[0].get("address").toString();
                Email = jsonObject[0].get("email").toString();
                Phone = jsonObject[0].get("phone").toString();
                Name = jsonObject[0].get("name").toString();
                onDutyAddress.setText(jsonObject[0].get("address").toString());
                onDutyPhone.setText(jsonObject[0].get("email").toString());
                onDutyName.setText(jsonObject[0].get("name").toString());
                JSONArray jsonArrays = jsonObject[0].getJSONArray("availability");
                int length = jsonArrays.length();
                if (length>0){
                    JSONObject mon_obj = jsonArrays.getJSONObject(0);
                    String monTime = mon_obj.getString("availableTime").toString();
                    JSONObject tue_obj = jsonArrays.getJSONObject(0);
                    String tueTime = tue_obj.getString("availableTime").toString();
                    JSONObject wen_obj = jsonArrays.getJSONObject(0);
                    String wenTime = wen_obj.getString("availableTime").toString();
                    JSONObject thus_obj = jsonArrays.getJSONObject(0);
                    String thusTime = thus_obj.getString("availableTime").toString();
                    JSONObject fri_obj = jsonArrays.getJSONObject(0);
                    String fri_time = fri_obj.getString("availableTime").toString();
                    onDutyMon.setText(monTime);
                    onDutyTue.setText(tueTime);
                    onDutyWen.setText(wenTime);
                    onDutyThur.setText(thusTime);
                    onDutyFri.setText(fri_time);
                }
                System.out.println(jsonArrays.length());
                System.out.println("request==============");
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }, error -> error.printStackTrace());

        requestQueue.add(jsonObjectRequest);
        System.out.println(data);
        return data;

    }



    public void ondutyUpdatenew(View view) throws JSONException {
        System.out.println("sssssssssssss");
        String onDutyAddress_text = onDutyAddress.getText().toString().trim();
        String onDutyPhone_text =onDutyPhone.getText().toString().trim();
        String onDutyName_text =onDutyName.getText().toString().trim();
        String mon = onDutyMon.getText().toString();
        String tue = onDutyTue.getText().toString();
        String wen = onDutyWen.getText().toString();
        String thur = onDutyThur.getText().toString();
        String fry = onDutyFri.getText().toString();
        System.out.println();
        if(onDutyAddress_text.isEmpty()){
            onDutyAddress.setError("Address Can't be empthy");
            onDutyAddress.requestFocus();
            return;
        }
        if(onDutyPhone_text.isEmpty()){
            onDutyPhone.setError("Phone Can't be empthy");
            onDutyPhone.requestFocus();
            return;
        }
        if(onDutyName_text.isEmpty()){
            onDutyName.setError("Name Can't be empthy");
            onDutyName.requestFocus();
            return;
        }

        String name_,address_,phone_ = "";
        if(!Address.equals(onDutyAddress_text)){
            address_=onDutyAddress_text;
        }else{
            address_=Address;
        }
        if(!Phone.equals(onDutyPhone_text)){
            phone_=onDutyPhone_text;
        }else{
            phone_=Phone;
        }
        if(!Name.equals(onDutyName_text)){
            name_=onDutyName_text;
        }else{
            name_=Name;
        }

        updateDoctor(Id,name_,Email,"","Dr ",phone_,address_,() -> {
            Toast.makeText(DutyCalling.this,"Doctor is Updated!",Toast.LENGTH_SHORT).show();
            Intent i = new Intent(DutyCalling.this,MedcFragment.class);
            startActivity(i);
        });
    }
}