package com.project.skidn_disease_app;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.preference.PreferenceManager;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.Volley;
import com.google.firebase.auth.FirebaseAuth;
import com.project.skidn_disease_app.Adapters.DoctorListAdapter;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link MedcFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class MedcFragment extends Fragment {

    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private SharedPreferences sharedPref;
    FirebaseAuth auth = FirebaseAuth.getInstance();
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";
    private RecyclerView recyclerView;
    View view;
    ArrayList<JSONObject> dataArrayList = new ArrayList<>();

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    public MedcFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment MedcFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static MedcFragment newInstance(String param1, String param2) {
        MedcFragment fragment = new MedcFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreateOptionsMenu(@NonNull Menu menu, @NonNull MenuInflater inflater) {
        inflater.inflate(R.menu.doctormenu, menu);
        super.onCreateOptionsMenu(menu, inflater);
    }
    public void setHasOptionsMenu(boolean hasMenu) {
        super.setHasOptionsMenu(hasMenu);
    }


    @Override
    public void onPrepareOptionsMenu(@NonNull Menu menu) {
        super.onPrepareOptionsMenu(menu);
        SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences(this.getContext());
        String UserId = settings.getString("userid", "");
        MenuItem item= menu.findItem(R.id.action_Onboarding_medec);
        if (UserId != null && !UserId.equals("")) {
            item.setTitle("LogOut");
        }
    }

    @Override
    public boolean onOptionsItemSelected(@NonNull MenuItem item) {
        int itemThatWasClickedId = item.getItemId();
        SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences(this.getContext());
        String UserId = settings.getString("userid", "");
        System.out.println(UserId);
        if(UserId!=null && !UserId.equals("")) {
            if(item.getTitle().equals("LogOut")){
                SharedPreferences.Editor editor = settings.edit();
                editor.putString("userid", "");
                editor.commit();
                item.setTitle("Onboarding");
            }
            if(item.getTitle().equals("Duty Calling")){
                Intent i = new Intent(this.getContext(), DutyCalling.class);
                i.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP| Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(i);
            }
        }else{
            System.out.println("UserId");
            System.out.println(UserId);
            System.out.println("UserId");
            if (itemThatWasClickedId == R.id.action_Duty_medec) {
                Intent intent = new Intent(getContext(),SingIn.class);
                startActivity(intent);
            }
            if (itemThatWasClickedId == R.id.action_Onboarding_medec) {
                Intent intent = new Intent(getContext(),Singup.class);
                startActivity(intent);
            }
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }
        setHasOptionsMenu(true);
        dataArrayList=getDoctors(new VolleyCallBack() {

            @Override
            public void onSuccess() {
                System.out.println("hello"+dataArrayList);
                recyclerView = view.findViewById(R.id.medecrecyele_view);
                recyclerView.setHasFixedSize(true);
                recyclerView.setLayoutManager(new LinearLayoutManager(view.getContext()));
                DoctorListAdapter medecAdapter = new DoctorListAdapter(view.getContext(),dataArrayList);
                recyclerView.setAdapter(medecAdapter);
            }});
        getActivity().setTitle("Medical Channling");
        getActivity().setTitleColor(R.color.bot_back_color);


    }


    public ArrayList<JSONObject> getDoctors(final VolleyCallBack callBack){
        String url = "https://i0qh9h.deta.dev/api/doctors";
        List<String> jsonResponses = new ArrayList<>();


        RequestQueue requestQueue = Volley.newRequestQueue(this.getContext());
        JsonArrayRequest jsonObjectRequest = new JsonArrayRequest(Request.Method.GET, url, null, response -> {
            System.out.println(response.getClass());

            for(int i=0; i < response.length(); i++) {
                JSONObject jsonobject = null;
                try {
                    jsonobject = response.getJSONObject(i);
                    System.out.println("xxx");
                    System.out.println(jsonobject);
                    System.out.println("xxx");
                    callBack.onSuccess();
                    dataArrayList.add(jsonobject);

                } catch (JSONException e) {
                    e.printStackTrace();
                }


            }
        }, error -> error.printStackTrace());

        requestQueue.add(jsonObjectRequest);
        return dataArrayList;

    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment

        view = inflater.inflate(R.layout.fragment_medc, container, false);
//        recyclerView = (RecyclerView) view.findViewById(R.id.medecrecyele_view);
        recyclerView = view.findViewById(R.id.medecrecyele_view);
        recyclerView.setHasFixedSize(true);
        recyclerView.setLayoutManager(new LinearLayoutManager(view.getContext()));
        DoctorListAdapter medecAdapter = new DoctorListAdapter(this.getContext(),dataArrayList);
        recyclerView.setAdapter(medecAdapter);
        return view;
    }

}